#include <qwt_curve.h>
#include <qwt_plot.h>

class QwtPlot;
class QwtPlotCurve;

class QwtErrorPlotCurve: public QwtPlotCurve
{
public:
	enum Orientation{Horizontal = 0, Vertical = 1};

	QwtErrorPlotCurve(int orientation, QwtPlot *parent, const char *name);
	QwtErrorPlotCurve(QwtPlot *parent, const char *name=0);
				  
	QwtDoubleRect boundingRect() const;

	virtual void draw(QPainter *painter,const QwtDiMap &xMap, 
		const QwtDiMap &yMap, int from, int to);

	virtual void drawErrorBars(QPainter *painter, const QwtDiMap &xMap, 
		const QwtDiMap &yMap, int from, int to);

	QwtArray<double> errors();
	void setErrors(const QwtArray<double>&data);
	void setSymbolSize(const QSize& sz);

	int capLength();
	void setCapLength(int t);

	int width();
	void setWidth(int w);

	QColor color();
	void setColor(const QColor& c);

	int direction(){return type;};
	void setDirection(int o){type = o;};

	bool xErrors();
	void setXErrors(bool yes);

	bool throughSymbol();
	void drawThroughSymbol(bool yes);

	bool plusSide();
	void drawPlusSide(bool yes);

	bool minusSide();
	void drawMinusSide(bool yes);

private:
    QwtArray<double> err;
	QPen pen;
	QSize size;
	int type, cap;
	bool plus, minus, through;
};
