#ifndef IMAGEMARKER_H
#define IMAGEMARKER_H

#include <qobject.h>
#include <qfont.h>
#include <qpen.h>
#include <qpaintdevicemetrics.h>
#include <qpixmap.h>
#include <qwt_plot_classes.h>
#include <qwt_marker.h>

class QWtPlot;
	
class ImageMarker: public QwtPlotMarker
{
public:
	ImageMarker(const QPixmap& p, QwtPlot *plot);
    virtual void draw(QPainter *p, int x, int y, const QRect &);
	
	QRect rect(){return QRect(origin,picSize);};

	void setSize(const QSize& size);
	QSize size(){return picSize;};
	
	void setOrigin(const QPoint& p);
	QPoint getOrigin();

	void setFileName(const QString& fn){fileName=fn;};
	QString getFileName(){return fileName;};
	
	QPixmap image(){return pic;};
private:
	QPoint origin;
	QPixmap pic;
	QSize picSize;
	QString fileName;
};

#endif
