#include <qwt_curve.h>
#include <qwt_plot.h>

class QwtPlot;
class QwtPlotCurve;

class VectXYXYCurve: public QwtPlotCurve
{
public:
	VectXYXYCurve(QwtPlot *parent, const char *name=0);
	~VectXYXYCurve();

	QwtDoubleRect boundingRect() const;

	virtual void draw(QPainter *painter,const QwtDiMap &xMap, 
		const QwtDiMap &yMap, int from, int to);

	virtual void drawVector(QPainter *painter, const QwtDiMap &xMap, 
		const QwtDiMap &yMap, int from, int to);
	
	void drawArrowHead(QPainter *p, int xs, int ys, int xe, int ye);
	double teta(int x0, int y0, int x1, int y1);

	void setVectorEnd(const QwtArray<double>&x, const QwtArray<double>&y);

	int width();
	void setWidth(int w);

	QColor color();
	void setColor(const QColor& c);
	
	int headLength(){return d_headLength;};
	void setHeadLength(int l);
	
	int headAngle(){return d_headAngle;};
	void setHeadAngle(int a);
	
	bool filledArrowHead(){return filledArrow;};
	void fillArrowHead(bool fill);
	
private:
	QwtArrayData *vectorEnd;
	QPen pen;
	bool filledArrow;
	int d_headLength, d_headAngle;
};
