#include <qobject.h>
#include "graph.h"
#include "plot.h"

class Graph;
class Plot;
	
class CanvasPicker: public QObject
{
    Q_OBJECT
public:
    CanvasPicker(Graph *plot);
    virtual bool eventFilter(QObject *, QEvent *);

private:
	void drawTextMarker(const QPoint&);
	void drawLineMarker(const QPoint&, bool endArrow);
	bool selectMarker(const QPoint& );
	void moveMarker(QPoint& );
	void drawMarker();

	Graph *plot() { return (Graph *)parent(); }
	
	Plot* plotWidget;	
	QPoint startLinePoint, endLinePoint;
	
	int xMouse, yMouse, xMrk, yMrk;
	bool moved,	movedGraph, resizedGraph, ShiftButton;	
	
signals:
	void showPieDialog();
	void showPlotDialog();
	void viewTextDialog();
	void viewLineDialog();
	void viewImageDialog();
	void drawTextOff();
	void showMarkerPopupMenu();
	void modified();
	void calculateProfile(const QPoint&, const QPoint&);
	void selectPlot();
	void moveGraph(const QPoint&);
	void resizeGraph(const QPoint&);
	void releasedGraph();
	void newSizeGraph();
};
