#include "colorBox.h"
#include "colors.h"

#include <qpixmap.h>
#include <algorithm>

const QColor ColorBox::colors[] = {
  QColor(black),
  QColor(red),
  QColor(green),
  QColor(blue),
  QColor(cyan),
  QColor(magenta),
  QColor(yellow),
  QColor(darkYellow),
  QColor(darkBlue),
  QColor(darkMagenta),
  QColor(darkRed),
  QColor(darkGreen),
  QColor(darkCyan),
  QColor(white),
  QColor(lightGray),
  QColor(darkGray),
};

ColorBox::ColorBox(bool rw, QWidget *parent) : QComboBox(rw, parent)
{
  init();
}

ColorBox::ColorBox(QWidget *parent) : QComboBox(parent)
{
  init();
}

void ColorBox::init()
{
  this->insertItem(QPixmap(black_xpm), tr( "black" ) );
  this->insertItem(QPixmap(red_xpm), tr( "red" ) );
  this->insertItem(QPixmap(green_xpm), tr( "green" ) );
  this->insertItem(QPixmap(blue_xpm), tr( "blue" ) );
  this->insertItem(QPixmap(cyan_xpm), tr( "cyan" ) );
  this->insertItem(QPixmap(magenta_xpm), tr( "magenta" ) );
  this->insertItem(QPixmap(yellow_xpm), tr( "yellow" ) );
  this->insertItem(QPixmap(darkYellow_xpm), tr( "dark yellow" ) );
  this->insertItem(QPixmap(darkBlue_xpm), tr( "navy" ) );
  this->insertItem(QPixmap(darkMagenta_xpm), tr( "purple" ) );
  this->insertItem(QPixmap(darkRed_xpm), tr( "wine" ) );
  this->insertItem(QPixmap(darkGreen_xpm), tr( "olive" ) );
  this->insertItem(QPixmap(darkCyan_xpm), tr( "dark cyan" ) );
  this->insertItem(QPixmap(white_xpm),tr( "white" ) );
  this->insertItem(QPixmap(lightGray_xpm), tr( "light gray" ) );
  this->insertItem(QPixmap(darkGray_xpm), tr( "dark gray" ) );
}

void ColorBox::setColor(const QColor& c)
{
  const QColor *ite = std::find(colors, colors + sizeof(colors), c);
  if (ite == colors + sizeof(colors))
    this->setCurrentItem(0); // default color is black. 
  else
    this->setCurrentItem(ite - colors);
}

QColor ColorBox::color() const
{
  size_t i = this->currentItem();
  if (i < sizeof(colors))
    return colors[this->currentItem()];
  else
    return QColor(black); // default color is black.
}
