#include "colorButton.h"

ColorButton::ColorButton(QWidget *parent) : QPushButton(parent)
{
init();
}

void ColorButton::init()
{
setPaletteBackgroundColor ( QColor(white) ) ;
setAutoDefault(false);
}

void ColorButton::setColor(const QColor& c)
{
if ( paletteBackgroundColor() == c)
	return;

setPaletteBackgroundColor ( c ) ;

int gray = qGray (c.red(), c.green(), c.blue());
if (gray > 128)
	setPaletteForegroundColor (QColor(black));
else
	setPaletteForegroundColor (QColor(white));
}

QColor ColorButton::color() const
{
return paletteBackgroundColor();
}
