#ifndef FITDIALOG_H
#define FITDIALOG_H

#include <qvariant.h>
#include <qdialog.h>

class QPushButton;
class QLineEdit;
class QComboBox;
class QWidgetStack;
class QWidget;
class QTextEdit;
class QListBox;
class QCheckBox;
class QLabel;

class fitDialog : public QDialog
{
    Q_OBJECT

public:
    fitDialog( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~fitDialog();

	void initFitPage();
	void initEditPage();

	QLabel* boxFunctionType;
	QCheckBox* boxUseBuiltIn;
	QWidgetStack* tw;
    QPushButton* buttonOk;
	QPushButton* buttonCancel;
	QPushButton* buttonClear;
	QComboBox* boxCurve;
	QComboBox* boxSolver;
	QLineEdit* boxParams;
	QLineEdit* boxFrom;
	QLineEdit* boxTo;
	QLineEdit* boxPoints, *boxTolerance;
	QWidget *fitPage, *editPage;
	QTextEdit *editBox, *explainBox, *boxFunction;
	QListBox *categoryBox, *funcBox;
	QLineEdit *boxName, *boxParam;
	QPushButton *btnAddFunc, *btnDelFunc, *btnContinue;
	QPushButton *buttonEdit, *btnAddTxt, *btnAddName;

public slots:
	void accept();
	void insertFunctionsList(const QStringList& list);
	void clearList();
	void setCurveNames(const QStringList& names);
	void setLimits(const QStringList& limits);
	void showFitPage();
	void showEditPage();
	void showFunctionsList(int category);
	void showParseFunctions();
	void showUserFunctions();
	void showExpresion(int function);
	void addFunction();
	void addFunctionName();
	void setBuiltInFunction(bool ok);
	void saveUserFunction();
	void removeUserFunction();
	void setBuiltInFunctionNames();
	void setBuiltInFunctions();
	bool containsUserFunctionName(const QString& s);

signals:
	void fit(const QString&,const QString&,const QStringList&,
				const QStringList&,double,double,int,int,double);

	void fitBuiltInFunction(const QString&,const QString&, const QStringList&, 
							double, double, int, int, double);

	void clearFunctionsList();
	void saveFunctionsList(const QStringList&);

protected:
	QStringList userFunctions, userFunctionNames;
	QStringList builtInFunctionNames, builtInFunctions;
};

#endif // FITDIALOG_H
