#include <stdio.h>
#include <math.h>

#include <qstring.h>
#include <qregexp.h>
#include <qmessagebox.h>
#include <qworkspace.h>

#include "liborigin/OPJFile.h"
#include "importOPJ.h"

ImportOPJ::ImportOPJ(ApplicationWindow *app, const QString& filename) 
	: mw(app),filename(filename) 
{
OPJFile opj((char *)filename.latin1());
opj.Parse();
importTables(opj);
}

bool ImportOPJ::importTables(OPJFile opj) 
{
for (int s=0; s<opj.numSpreads();s++) 
	{	
	int nr_cols = opj.numCols(s);
	int maxrows = opj.maxRows(s);

	Table *table = mw->newTable(opj.spreadName(s), maxrows, nr_cols);
	if (!table)
		return false;
	
	for (int j=0; j<nr_cols; j++) 
		{
		QString name(opj.colName(s,j));
		table->setColName(j, name.replace(QRegExp(".*_"),""));

		if (QString(opj.colType(s,j)) == "X")
			{
			table->setSelectedCol(j);
			table->setXCol();
			}
		else if (QString(opj.colType(s,j)) == "Y")
			{
			table->setSelectedCol(j);
			table->setYCol();
			}

		bool emptyCol = true;
		int i;
		for (i=0; i<opj.numRows(s,j); i++) 
			{
			if (opj.Data(s,j)[i] != 0)
				{
				emptyCol = false; //not all cells are 0 <=> col is not empty
				break;
				}
			}

		if (!emptyCol)
			{
			for (i=0; i<opj.numRows(s,j); i++) 
				table->setText(i, j, QString::number(opj.Data(s,j)[i]));
			}
			
		table->showNormal();
		}
	}
mw->ws->cascade ();
return true;
}

