#ifndef INTDIALOG_H
#define INTDIALOG_H

#include <qvariant.h>
#include <qdialog.h>
#include <qvaluelist.h> 

class QButtonGroup;
class QPushButton;
class QCheckBox;
class QLineEdit;
class QComboBox;
class QSpinBox;
	
class intDialog : public QDialog
{
    Q_OBJECT

public:
    intDialog( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~intDialog();

    QPushButton* buttonOk;
	QPushButton* buttonCancel;
	QPushButton* buttonHelp;
    QButtonGroup* GroupBox1, *GroupBox2;
    QCheckBox* boxShowFormula;
	QComboBox* boxName;
	QSpinBox* boxOrder;
	QSpinBox* boxSteps;
	QLineEdit* boxStart;
	QLineEdit* boxEnd;
	QLineEdit* boxTol;
	

public slots:
    virtual void languageChange();
	void accept();
	void setCurveNames(const QStringList& names);
	void getMinMax(double *m,double *mm,int curves,int *p);
	void changeCurve(int curve);
	void setCurveLimits(int curve, double xMin, double xMax);
	void help();

signals:
	void options(int,int,int,double,double,double);

private:
	QValueList<double> Xmin;
	QValueList<double> Xmax;
	QValueList<int> points;
};

#endif // EXPORTDIALOG_H
