#include <qapplication.h>
#include <qtextcodec.h>
#include <qaction.h>
#include "application.h"

int main( int argc, char ** argv ) 
	{
    QApplication a( argc, argv );
	ApplicationWindow * mw;

	QTranslator trans;
	trans.load(QString("qtiplot_") + QTextCodec::locale(), qApp->applicationDirPath() + "/translations");
	a.installTranslator(&trans);

	QTranslator qtrans;
	qtrans.load(QString("qt_") + QTextCodec::locale(), qApp->applicationDirPath() + "/translations/qt/");
	a.installTranslator(&qtrans);

	if (a.argc()==2)
		{
		QString fname=a.argv()[1];
		mw = new ApplicationWindow(fname);
		}
	else
		{
		mw = new ApplicationWindow();
		mw->newTable();
		mw->setCaption("QtiPlot - untitled");
		mw->showMaximized();
		mw->saved=TRUE;
		mw->actionSaveProject->setEnabled(false);
		}

    a.connect( &a, SIGNAL(lastWindowClosed()), &a, SLOT(quit()) );
    int res = a.exec();
    return res;	
}
