#include "matrixSizeDialog.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qbuttongroup.h>
#include <qspinbox.h>
#include <qhbox.h>

matrixSizeDialog::matrixSizeDialog( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "matrixSizeDialog" );
    setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, sizePolicy().hasHeightForWidth() ) );
    setMouseTracking( false );
		
	QHBox  *hbox1=new QHBox (this, "hbox1"); 
	hbox1->setMargin (5);
	hbox1->setSpacing (5);

	new QLabel( tr( "Rows" ), hbox1, "TextLabel2",0 );
    boxRows = new QSpinBox(0,1000000,1, hbox1, "boxRows" );

	new QLabel( tr( "Columns" ), hbox1, "TextLabel2",0 );
    boxCols = new QSpinBox(0,1000000,1, hbox1, "boxCols" );

	GroupBox1 = new QButtonGroup( 2,QGroupBox::Horizontal,tr(""),this,"GroupBox1" );
	GroupBox1->setFlat(TRUE);
	GroupBox1->setLineWidth(0);
	
	buttonOk = new QPushButton(GroupBox1, "buttonOk" );
    buttonOk->setAutoDefault( TRUE );
    buttonOk->setDefault( TRUE );
   
    buttonCancel = new QPushButton(GroupBox1, "buttonCancel" );
    buttonCancel->setAutoDefault( TRUE );
	
	QVBoxLayout* hlayout = new QVBoxLayout(this,5,5, "hlayout");
    hlayout->addWidget(hbox1);
	hlayout->addWidget(GroupBox1);

    languageChange();
   
    // signals and slots connections
    connect( buttonOk, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( buttonCancel, SIGNAL( clicked() ), this, SLOT( reject() ) );
}

matrixSizeDialog::~matrixSizeDialog()
{
}

void matrixSizeDialog::setColumns(int c)
{
boxCols->setValue(c);
}

void matrixSizeDialog::setRows(int r)
{
boxRows->setValue(r);
}

void matrixSizeDialog::languageChange()
{
    setCaption( tr( "QtiPlot - Matrix Dimensions" ) );
    buttonOk->setText( tr( "&OK" ) );
	buttonCancel->setText( tr( "&Cancel" ) );
}

void matrixSizeDialog::accept()
{
emit changeDimensions(boxRows->value(), boxCols->value());
close();
}
