#include <qwt_curve.h>
#include <qwt_plot.h>
#include <qrect.h>

class QwtPlot;
class QwtPlotCurve;

class QwtPieCurve: public QwtPlotCurve
{
public:
	QwtPieCurve(QwtPlot *parent, const char *name=0);

	virtual void draw(QPainter *painter,const QwtDiMap &xMap, 
		const QwtDiMap &yMap, int from, int to);

	virtual void drawPie(QPainter *painter, const QwtDiMap &xMap, 
		const QwtDiMap &yMap, int from, int to);

public slots:
	QColor color(int i);
	QPoint center();
	int ray(){return pieRay;};
	void setRay(int size);
	QPen QwtPieCurve::pen(){return piePen;};
	void setPen(const QPen& p);
	Qt::BrushStyle pattern();
	void setBrushStyle(const Qt::BrushStyle& style);
	void setFirstColor(int index);
	int QwtPieCurve::first(){return firstColor;};
	QwtDiMap scaleMap(QPainter *p,int axis);
	
private:
	int pieRay,firstColor;
	QPen piePen;
	Qt::BrushStyle brushStyle;
};
