#ifndef POLINOMFITDIALOG_H
#define POLINOMFITDIALOG_H

#include <qvariant.h>
#include <qdialog.h>

class QButtonGroup;
class QPushButton;
class QCheckBox;
class QLineEdit;
class QComboBox;
class QSpinBox;
	
class polynomFitDialog : public QDialog
{
    Q_OBJECT

public:
    polynomFitDialog( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~polynomFitDialog();

	QPushButton* buttonFit;
    QPushButton* buttonOk;
	QPushButton* buttonCancel;
    QButtonGroup* GroupBox1, *GroupBox2;
    QCheckBox* boxShowFormula;
	QComboBox* boxName;
	QSpinBox* boxOrder;
	QSpinBox* boxPoints;
	QLineEdit* boxStart;
	QLineEdit* boxEnd;

public slots:
    virtual void languageChange();
	void fit();
	void accept();
	void setCurveNames(const QStringList& names);
	void setXLimits(double *m,double *mm,int curves, int *p);
	void setCurveLimits(int curve, double xMin, double xMax);
	void changeCurve(int curve);

signals:
	void options(const QString&,int,int,double,double,bool);

private:
	QValueList<double> Xmin;
	QValueList<double> Xmax;
	QValueList<int> points;
};

#endif // EXPORTDIALOG_H
